#include <SoftwareSerial.h>
#include <string.h>

SoftwareSerial mySerial(4,5); // RX, TX

boolean isRunning = false;

int stepSize[] = {0,1,2,3,7};
int stepCount[] = {1,10,100,500,1000,3000,5000};
int M1Pin = 12;
int M2Pin = 11;
int M3Pin = 10;

int dirPin = 8;
int dir = 0;
int stepPin = 9;
int triggerPin = 7;

int stepParam = 0;
int stepCountParam = 3;
int dirParam = 0;
long intervalParam = 0;

int picCount=0;


String msg;

void setup() {
  Serial.begin(9600);
  mySerial.begin(9600);
  // put your setup code here, to run once:
  pinMode(M1Pin,OUTPUT);
  pinMode(M2Pin,OUTPUT);
  pinMode(M3Pin,OUTPUT);
  pinMode(dirPin,OUTPUT);
  pinMode(stepPin,OUTPUT);
  pinMode(triggerPin,OUTPUT);
  digitalWrite(triggerPin,LOW);

}

void loop() {
  
   if (mySerial.available()) 
    {  
      msg = mySerial.readString();
      Serial.println(msg);
      parseParams(msg);
    }
   
}

void setStepSize(int n)
{
  Serial.print("stepSize ");
  Serial.print(n);
  Serial.print("  b");
  Serial.println(stepSize[n],BIN);
  
  
  digitalWrite(M1Pin,(stepSize[n] & 1));
  digitalWrite(M2Pin,(stepSize[n] & 2));
  digitalWrite(M3Pin,(stepSize[n] & 4));
}

 void parseParams(String param)
{

  String Strlong;
  
  switch(param.charAt(0))
  {
    case '#':
      Serial.println("bump");
      bump(stepCount[stepCountParam]);
      break;
    case '@':
      Serial.println("start");
      isRunning=true;
      startCamera();
      break;
    case 'X':
      Serial.println("stop");
      break;
    default:

        stepParam=param.charAt(0)-49;
        setStepSize(stepParam);

        dirParam=param.charAt(1)-49;
        digitalWrite(dirPin,dirParam);

        stepCountParam=param.charAt(2)-49;
        
        Strlong = param.substring(3,param.length()-1);
        intervalParam=Strlong.toInt();
 

        
        Serial.print("step = ");
        Serial.println(stepParam);
        Serial.print("dir = ");
        Serial.println(dirParam);
        Serial.print("interval = ");
        Serial.println(intervalParam);
  }   
} 

void bump(int n)
{
  digitalWrite(dirPin,dirParam);
  Serial.print("dir pin =");
  Serial.println(dirParam);
  Serial.print("stepCountParam = ");
  Serial.println(stepCountParam);
  Serial.print("stepCount[stepCountParam] =");
  Serial.println(stepCount[stepCountParam]);
  for (int i = 1; i <= n; i++)
  {
    delay(1);
    digitalWrite(stepPin,HIGH);
    digitalWrite(stepPin,LOW);
  }
  Serial.println();    
}

void startCamera()
{
  picCount=0;
  while (true)
  {
   if (mySerial.available()) 
    {  
      msg = mySerial.readString();
      if (msg[0]=='X') return;
    }
    
    
    Serial.println("Click");
    digitalWrite(13, HIGH);
    releaseShutter();
    picCount++;
    Serial.println(picCount);
    delay(4000);
    digitalWrite(13,LOW);
    bump(stepCount[stepCountParam]);
    if (intervalParam > 4500)
      delay(intervalParam-500);
    mySerial.println(picCount);
  }
}  

void releaseShutter()
{
  digitalWrite(triggerPin, HIGH);
  delay(500);
  digitalWrite(triggerPin, LOW);
}

  

